attribute vec4 vert_position;
attribute vec3 vert_normal;
attribute vec3 vert_diru;
attribute vec2 vert_texcoord;

varying highp vec3 normal;
varying mediump vec2 texcoord;

uniform mediump vec3 lightdir;

uniform vec3 camx;
uniform vec3 camy;
uniform vec3 camz;
uniform vec3 camw;
uniform vec2 screenScale;

void main()
{
	vec4 tpos;

	tpos.xyw = 
		camx*vert_position.x +
		camy*vert_position.y +
		camz*vert_position.z +
		camw;
		
	tpos.xy *= screenScale.xy;

	tpos.z = tpos.w-0.1; // near plane
	

    gl_Position = tpos;
	texcoord = vert_texcoord;

	highp vec3 cnormal,cdiru,cdirv;

	cnormal = 
		camx*vert_normal.x +
		camy*vert_normal.y +
		camz*vert_normal.z;


	cdiru = 
		camx*vert_diru.x +
		camy*vert_diru.y +
		camz*vert_diru.z;

	cdirv = -cross(cdiru,cnormal);

	normal.x = dot(lightdir,cdiru);
	normal.y = dot(lightdir,cdirv);
	normal.z = dot(lightdir,cnormal);
	normal = (normal);
}