attribute vec4 vert_position;
attribute vec3 vert_normal;
attribute vec3 vert_diru;
attribute vec2 vert_texcoord;

varying mediump vec3 color;

uniform vec3 camx;
uniform vec3 camy;
uniform vec3 camz;
uniform vec3 camw;
uniform vec3 screenScale;
uniform mediump vec3 lightdir;

void main()
{
	vec4 tpos;

	tpos.xyw = 
		camx*vert_position.x +
		camy*vert_position.y +
		camz*vert_position.z +
		camw;
		
	tpos.xy *= screenScale.xy;
	tpos.z = tpos.w-0.1; // near plane

    gl_Position = tpos;
	
	
	mediump vec3 cnormal,cdiru,cdirv;

	cnormal = 
		camx*vert_normal.x +
		camy*vert_normal.y +
		camz*vert_normal.z;
	
	color = mix( vec3(0.1,0.15,0.2)*0.7, vec3(0.2,0.15,0)*0.7, (1.0-dot(cnormal,lightdir))/2.0)*screenScale.z;

}